unit uTestCase;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, CurvFitt, Series, ExtCtrls, TeeProcs, Chart, TeeEdit;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    LabData: TPointSeries;
    CurveFit: TFastLineSeries;
    TTeeFunction1: TCurveFittingFunction;
    ChartEditor1: TChartEditor;
    SmoothFit: TFastLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses math;

{$R *.dfm}

procedure PlotSmoothFit( var serFit, serSmoothFit : tFastLineSeries;
                         FitFctn : TCurveFittingFunction;
                         smoothness : integer );

var interval, x, y : double; i, imax : integer; coeffs : array of double;

begin
  with FitFctn do begin
    imax := polydegree;
    SetLength( coeffs, imax );
    for i := 1 to imax do
      coeffs[ i-1 ] := AnswerVector[ i ];
    { end }
  end;
  with serFit do begin
    interval := ( maxXvalue - minXvalue )/ Smoothness;
    for i := 1 to Smoothness do begin
      x := minXvalue + (i-1) * interval;
      y := poly( x-minXvalue, coeffs ) + minYvalue;
      serSmoothFit.AddXY( x, y )
    end;
  end
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  tTeeFunction1.PolyDegree := 2;
  with LabData do begin
    AddXY( 1.808, log10( 85 ));
    AddXY( 1.876, log10( 130 ));
    AddXY( 1.949, log10( 280 ));
    AddXY( 2.070, log10( 840 ));
  end;
  tTeeFunction1.AddPoints( LabData );
  PlotSmoothFit( CurveFit, SmoothFit, tTeeFunction1, 500 );
end;

procedure TForm1.Chart1DblClick(Sender: TObject);
begin
  ChartEditor1.Execute
end;

end.
